searchNodes=[{"doc":"Basic instrumentation library to intercept and collect Plug pipeline connection parameters for further reporting, monitoring or analysis with user provided callback function. Functionality provided by PlugCollect is very similar to one offered by Plug.Conn.register_before_send/2 function. register_before_send/2 registers a callback to be invoked before the response is sent. When using register_before_send/2 , user defined callback will not be invoked if response processing pipeline raises. PlugCollect similarly to register_before_send/2 registers a callback to be invoked before sending response, however callback function is always executed, even if response pipeline fails. Usage Add use PlugCollect to your application's Phoenix endpoint or router, for example: #router.ex defmodule MyAppWeb.Router do use MyAppWeb , :router use PlugCollect , collect_fun : &amp; MyApp.MyModule . my_collect / 2 # ... end Using PlugCollect requires :collect_fun parameter specifying a user defined callback function with two arity. Callback function defined by :collect_fun key has following characteristics: As a first argument function will receive an atom :ok or :error describing request pipeline processing status. :ok atom means that intercepted request was processed successfully by Plug pipeline. :error means that during request processing, pipeline raised, exited or did throw an error. As a second argument function will receive a Plug.Conn struct with current pipeline connection. Callback function is invoked on each Plug request, after processing entire Plug pipeline defined below use PlugCollect statement. Function is executed even if code declared after use PlugCollect raises, exits or throws an error. Callback function is executed synchronously. It should not contain any blocking or costly IO operations, as it would delay or block sending request response to the user. Callback function result is ignored. Example :collect_fun implementation: defmodule MyApp.MyModule do def my_collect ( :ok , % Plug.Conn { assigns : assigns } = _conn ) , do : Logger . metadata ( user_id : Map . get ( assigns , :user_id ) ) def my_collect ( _status , _conn ) , do : :ok end","ref":"PlugCollect.html","title":"PlugCollect","type":"module"},{"doc":"Basic instrumentation library to intercept and collect Plug pipeline connection parameters for further reporting, monitoring or analysis with user provided function. PlugCollect is inspired by other similar libraries: Appsignal.Plug , Sentry.PlugCapture .","ref":"readme.html","title":"PlugCollect","type":"extras"},{"doc":"Add plug_collect to your application dependencies list in mix.exs : #mix.exs def deps do [ { :plug_collect , github : &quot;recruitee/plug_collect&quot; , branch : &quot;master&quot; } ] end","ref":"readme.html#installation","title":"PlugCollect - Installation","type":"extras"},{"doc":"Add use PlugCollect to your application's Phoenix endpoint or router, for example: #endpoint.ex defmodule MyAppWeb.Endpoint do use PlugCollect , collect_fun : &amp; MyApp.Monitor . my_collect / 2 use Phoenix.Endpoint , otp_app : :my_app # ... Callback function MyApp.Monitor.my_collect/2 will be invoked on each request. Example :collect_fun callback implementation: defmodule MyApp.Monitor do def my_collect ( _status , % Plug.Conn { assigns : assigns } = _conn ) , do : Logger . metadata ( user_id : Map . get ( assigns , :user_id ) ) end","ref":"readme.html#usage","title":"PlugCollect - Usage","type":"extras"}]